# -*- coding: utf-8 -*-
"""
Created on Tue Oct 27 18:28:11 2020

@author: utilisateur
"""

from math import *
from statistics import *
import matplotlib.pyplot as plt
import numpy as np
import scipy.stats as stat

# n=100
# alpha=0.5
# beta=1
# X0 = stat.norm.rvs(loc=50,scale=10,size=n)
# Y0 = np.zeros(n)

# for i in range(n):
#     Y0[i] = np.array(alpha*X0[i] + beta) + np.array(stat.norm.rvs(loc=0,scale=1,size=1))
    
# plt.scatter(X0,Y0)

circ = open("circ.txt","r")
h = open("h.txt","r")

yR1 = [line.split('. ') for line in circ.readlines()]
yR2 = [line.split(' ') for line in h.readlines()]

X = yR1[0]
Y = yR2[0]
for i in range(len(X)) :
    X[i] = float(X[i])
    Y[i] = float(Y[i])
X,Y = np.array(X),np.array(Y)
    
def premiertrace(x,y):
     plt.scatter(x,y,c='black',marker='+')
     plt.xlabel('Circonference')
     plt.ylabel('Hauteur')

xbar,ybar = mean(X),mean(Y)
beta2 = sum((X-xbar)*Y)/sum((X-xbar)*(X-xbar))
beta1 = ybar - beta2*xbar

def trace2(x,y,alpha,beta):
    x0 = np.linspace(25,77,10)
    y0 = alpha+beta*x0
    plt.plot(x0,y0,c='red')
    plt.scatter(x,y,c='black',marker='+')
    plt.xlabel('Circonference')
    plt.ylabel('Hauteur')
    
Z = np.ones((1429,3))
Z[:,1] = X.reshape([1429,])
Z[:,2] = np.sqrt(X.reshape([1429,]))
beta0 = np.linalg.inv(np.transpose(Z).dot(Z)).dot(np.transpose(Z)).dot(Y.reshape([1429,1]))

def trace3(x,y,beta):
    x0 = np.linspace(25,77,100)
    y0 = beta[0] + beta[1]*x0 + beta[2]*np.sqrt(x0)
    plt.plot(x0,y0,c='blue')
    plt.scatter(x,y,c='black',marker='+')
    plt.xlabel('Circonference')
    plt.ylabel('Hauteur')
    
Z2 = np.ones((1429,3))
Z2[:,1] = X.reshape([1429,])
Z2[:,2] = np.log(1+X.reshape([1429,]))
betatilde = np.linalg.inv(np.transpose(Z2).dot(Z2)).dot(np.transpose(Z2)).dot(Y.reshape([1429,1]))

def trace4(x,y,b1,b2):
    x0 = np.linspace(25,77,100)
    y0 = b2[0] + b2[1]*x0 + b2[2]*np.log(1+x0)
    plt.plot(x0,y0,c='green')
    y1 = b1[0] + b1[1]*x0 + b1[2]*np.sqrt(x0)
    plt.plot(x0,y1,c='blue')
    y2 = beta1+beta2*x0
    plt.plot(x0,y2,c='red')
    plt.scatter(x,y,c='black',marker='+')
    plt.xlabel('Circonference')
    plt.ylabel('Hauteur')
    
def trace41(x,y,beta):
    x0 = np.linspace(25,77,100)
    y0 = beta[0] + beta[1]*x0 + beta[2]*np.log(1+x0)
    plt.plot(x0,y0,c='green')
    plt.scatter(x,y,c='black',marker='+')
    plt.xlabel('Circonference')
    plt.ylabel('Hauteur')
    
#n=1429
#p=3
    
def test_stud(z,y,beta,alpha): #alpha precision pour le quantile (typ. 0.05)
    n,p=len(z),len(z[0])
    quantile_ref = stat.t.ppf(1-alpha/2,df=n-p)
    xb = z.dot(beta)
    sigma2 = sum([(y[i] - xb[i])**2 for i in range(len(y))])
    T = np.sqrt(beta[p-1] * sigma2 / (n-p))
    if T > quantile_ref :
        print("L'hypothèse est rejetée : le dernier terme est significatif.")
    else:
        print("L'hypothèse n'est pas rejetée : le dernier terme peut ne pas être significatif.")
    
Z3 = np.ones((1429,3))
Z3[:,1] = X.reshape([1429,])
Z3[:,2] = X.reshape([1429,])**2
beta3 = np.linalg.inv(np.transpose(Z3).dot(Z3)).dot(np.transpose(Z3)).dot(Y.reshape([1429,1]))

#premiertrace(X,Y)    
#trace2(X,Y,beta1,beta2)            #lineaire
#trace3(X,Y,beta0)                  #sqrt
#trace41(X,Y,betatilde)             #log(1+x)
#trace4(X,Y,beta0,betatilde)        #log + sqrt + lineaire
#test_stud(Z,Y,beta0,0.05)          #le test pour sqrt
#test_stud(Z2,Y,betatilde,0.05)     #le test pour log
#test_stud(Z3,Y,beta3,0.05)         #le test pour x**2

